module Highlighter.Highlighter where

import Data.Text
import Common
import System.Console.ANSI (Color(..), Underlining(..), SGR(..), setSGRCode)

underlineText :: Text -> Text
underlineText t = let
  startCode = (setSGRCode [SetUnderlining SingleUnderline])
  endCode = setSGRCode []
  in (pack startCode) <> t <> (pack endCode)

colorText :: Color -> Color -> Text -> StyledText
colorText fg bg t = StyledText (FgBg fg bg) [Plain t]

colorTextFg :: Color -> Text -> StyledText
colorTextFg fg t = StyledText (Fg fg) [Plain t]
